/*******************************************************************************
 * 
 * jKiwi -- A virtual makeover and hairstyler application
 * Copyright (c) 2007-2008 Dan Mihai Ile, Maria Joao Roque Barbado Leal
 * 
 * This file is part of jKiwi.
 * 
 * jKiwi is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * jKiwi is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************/

package core;


import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

/**
 * Class unused by this version
 */
public class MirrorButton extends Canvas {

//	private static final RGB SELECTED_COLOR = new RGB(0,0,255);

	private Color backgroundColor = null;
//	private Color outerColor = null;
//	private Color innerColor = null;
//	private Color myWhite = null;
//	private Color foregroundUpperColor_myWhite = null;
//	private Color foregroundLowerColor_myWhite = null;
//	private Color mouseUpWhite = null;
//	private Color mouseDownWhite = null;
//	private Color selectedColor = null;

//	private boolean isSelected = false;

	private Color borderColor;

	private Color originalBackground;

	public MirrorButton(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
		setLayout(new GridLayout());
//		this.setSize(new Point(22, 26));

		originalBackground = new Color(Display.getCurrent(), 239, 235, 231);

		backgroundColor = new Color(Display.getCurrent(), 239, 235, 231);

		borderColor = new Color(Display.getCurrent(), 177, 165, 152);


		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				MirrorButton.this.widgetDisposed(e);
			}
		});

		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				GC gc = e.gc;
				gc.setBackground(backgroundColor);
				int width = getSize().x-1;
				int height = getSize().y-1;

				//background colors
				gc.setBackground(new Color(Display.getCurrent(), 255, 255, 255));
				gc.fillRectangle(new Rectangle(0,0,width+1,height+1));
				gc.setBackground(backgroundColor);
				gc.fillRectangle(new Rectangle(2,2,width - 3,height - 3 - 20));

				//draw 1px borders around button
				gc.setForeground(borderColor);
				gc.drawRectangle(0, 0, width, height - 20);
				gc.setForeground(new Color(Display.getCurrent(), 255, 255, 255));
				gc.drawRectangle(1, 1, width - 2, height - 2 - 20);

				/**
				 * mirror down here
				 */

				//line
				gc.setForeground(new Color(Display.getCurrent(), 217, 205, 192));
				gc.drawLine(0, height - 18, width, height - 18);

				//fill gradient
				gc.setBackground(new Color(Display.getCurrent(), 255, 255, 255));
				gc.setForeground(backgroundColor);
				gc.fillGradientRectangle(2, height - 16, width - 3, 20, true);

				//lines left & right fill
				gc.setBackground(new Color(Display.getCurrent(), 255, 255, 255));
				gc.setForeground(new Color(Display.getCurrent(), 217, 205, 192));
				gc.fillGradientRectangle(0, height - 18, 1, 20, true);
				gc.fillGradientRectangle(width, height - 18, 1, 20, true);

			}
		});

		this.addMouseTrackListener(new org.eclipse.swt.events.MouseTrackAdapter() {   
			public void mouseExit(org.eclipse.swt.events.MouseEvent e) {
				setBackground(originalBackground);
				redraw();
			}
			public void mouseEnter(org.eclipse.swt.events.MouseEvent e) {
				setBackground(new Color(Display.getCurrent(), 249, 245, 241));
				redraw();
			}

		});
		this.addMouseListener(new org.eclipse.swt.events.MouseAdapter() {   
			public void mouseUp(org.eclipse.swt.events.MouseEvent e) {    
			}
			public void mouseDown(org.eclipse.swt.events.MouseEvent e) {
			}

		});
	}

	public Point computeSize(int wHint, int hHint, boolean changed) {
		int width = 200, height = 60;
		return new Point(width, height);    
	}

	protected void widgetDisposed(DisposeEvent e) {
//		backgroundColor.dispose();
//		outerColor.dispose();
//		innerColor.dispose();
//		myWhite.dispose();
//		foregroundUpperColor_myWhite.dispose();
//		foregroundLowerColor_myWhite.dispose();
//		mouseUpWhite.dispose();
//		mouseDownWhite.dispose();
//		selectedColor.dispose();
	}

	@Override
	public void setBackground(Color bkColor) {
		backgroundColor = bkColor;
	}

	@Override
	public Color getBackground() {
		return backgroundColor;
	}
}